#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6

#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>

Opt( "MustDeclareVars", 1 )

Global $idListView, $hListView

Example()

Func Example()
  GUICreate("Listview", 220, 250, 300, 200, -1, $WS_EX_ACCEPTFILES)

  $idListView = GUICtrlCreateListView("NO1  |NO2|NO3  ", 10, 10, 200, 150, $GUI_SS_DEFAULT_LISTVIEW-$LVS_SINGLESEL)
  GUICtrlCreateListViewItem ("A1|A2|A3", $idListView)
  GUICtrlCreateListViewItem ("B1|B2|B3", $idListView)
  GUICtrlCreateListViewItem ("C1|C2|C3", $idListView)
  GUICtrlCreateListViewItem ("D1|D2|D3", $idListView)
  GUICtrlCreateListViewItem ("E1|E2|E3", $idListView)
  $hListView = GUICtrlGetHandle( $idListView )

  Local $idButton = GUICtrlCreateButton("Button", 75, 170, 70, 20)
  GUICtrlCreateInput("", 20, 200, 150)

  GUISetState()
  GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")

  While 1
    Switch GUIGetMsg()
      Case $idButton
        MsgBox(0, "", GUICtrlRead(GUICtrlRead($idListView)), 2)
      Case $idListView
        MsgBox(0, "", "" & GUICtrlGetState($idListView), 2)
      Case $GUI_EVENT_CLOSE
        ExitLoop
    EndSwitch
  WEnd
EndFunc

Func WM_NOTIFY( $hWnd, $iMsg, $wParam, $lParam )
  Static $hDC, $iItem, $hBrush = DllCall( "gdi32.dll", "handle", "CreateSolidBrush", "int", _WinAPI_GetSysColor( $COLOR_HIGHLIGHT ) )[0] ; Selected back color, _WinAPI_CreateSolidBrush
  Static $tRect = DllStructCreate( $tagRECT ), $pRect = DllStructGetPtr( $tRect ), $tLVitem = DllStructCreate( $tagLVITEM ), $pLVitem = DllStructGetPtr( $tLVitem ), $tBuffer = DllStructCreate( "wchar Text[4096]" ), $pBuffer = DllStructGetPtr( $tBuffer )
  Local $tNMHDR = DllStructCreate($tagNMHDR, $lParam)
  Switch HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
    Case $hListView
      Switch DllStructGetData($tNMHDR, "Code")
        Case $NM_CUSTOMDRAW
          Local $tNMLVCUSTOMDRAW = DllStructCreate( $tagNMLVCUSTOMDRAW, $lParam )
          Switch DllStructGetData( $tNMLVCUSTOMDRAW, "dwDrawStage" )
            Case $CDDS_PREPAINT                              ; Before the paint cycle begins
              $hDC = DllStructGetData( $tNMLVCUSTOMDRAW, "hdc" )                              ; Device context
              DllCall( "gdi32.dll", "int", "SetBkMode", "handle", $hDC, "int", $TRANSPARENT ) ; Transparent background, _WinAPI_SetBkMode
              Return $CDRF_NOTIFYITEMDRAW                    ; Notify the parent window before an item is painted

            Case $CDDS_ITEMPREPAINT                          ; Before an item is painted
              $iItem = DllStructGetData( $tNMLVCUSTOMDRAW, "dwItemSpec" ) ; Item index
              If GUICtrlSendMsg( $idListView, $LVM_GETITEMSTATE, $iItem, $LVIS_SELECTED ) Then _ ; Selected item?
                Return $CDRF_NOTIFYPOSTPAINT                 ; Custom drawing of selected items
              Return $CDRF_NEWFONT                           ; Default drawing of other items

            Case $CDDS_ITEMPOSTPAINT                         ; After an item has been painted
              DllCall( "gdi32.dll", "int", "SetTextColor", "handle", $hDC, "int",  0xFFFFFF ) ; Selected fore color, white, _WinAPI_SetTextColor
              ; For each subitem
              For $iSubItem = 0 To 2
                ; Subitem rectangle
                DllStructSetData( $tRect, "Top", $iSubItem )
                DllStructSetData( $tRect, "Left", $LVIR_LABEL )
                GUICtrlSendMsg( $idListView, $LVM_GETSUBITEMRECT, $iItem, $pRect )
                DllStructSetData( $tRect, "Left", DllStructGetData( $tRect, "Left" ) )

                ; Selected back color
                DllCall( "user32.dll", "int", "FillRect", "handle", $hDC, "struct*", $tRect, "handle", $hBrush ) ; _WinAPI_FillRect

                ; Left and top margin of subitem text
                DllStructSetData( $tRect, "Left", DllStructGetData( $tRect, "Left" ) + ( $iSubItem ? 6 : 2 ) )
                DllStructSetData( $tRect, "Top", DllStructGetData( $tRect, "Top" ) + 2 )

                ; Extract subitem text from listview
                DllStructSetData( $tLVitem, "Mask", $LVIF_TEXT )
                DllStructSetData( $tLVitem, "SubItem", $iSubItem )
                DllStructSetData( $tLVitem, "Text", $pBuffer )
                DllStructSetData( $tLVitem, "TextMax", 4096 )
                GUICtrlSendMsg( $idListView, $LVM_GETITEMTEXTW, $iItem, $pLVitem )

                ; Draw subitem text with selected fore color and selected text font (through the device context, $hDC)
                DllCall( "user32.dll", "int", "DrawTextW", "handle", $hDC, "wstr", DllStructGetData( $tBuffer, "Text" ), "int", -1, "struct*", $tRect, "uint", $DT_WORD_ELLIPSIS ) ; _WinAPI_DrawText
              Next
              Return $CDRF_NEWFONT                           ; $CDRF_NEWFONT must be returned after changing font or colors
          EndSwitch
      EndSwitch
  EndSwitch
  #forceref $hWnd, $iMsg, $wParam
EndFunc