#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>
#include <WinAPIEx.au3>
#include <Constants.au3>

_Example()

Func _Example()

    Local $hGui, $sURL = "https://www.google.co.uk"
    Local $iLeft = 0, $iTop = 0, $iWidth = 1024, $iHeight = 768

    $hGui = GUICreate("Test", $iWidth, $iHeight)
    Local $aMain = ChromeCreatePseudoEmbedded($iLeft, $iTop, $iWidth, $iHeight, $hGUI, $sURL)


    While 1
        $msg = GUIGetMsg()
        If $msg = $GUI_EVENT_CLOSE Then
            WinClose($aMain[1]) ; Chrome kiosk window
            WinClose($hGui) ; Own gui
            ;ProcessClose($aMain[0]) ; Chrome executable
            ProcessWaitClose($aMain[0]) ; Chrome executable
            Exit
        EndIf
    WEnd

EndFunc   ;==>_Example

;Returns a 1D array where [0] is the process id of the chrome executable which is launched
;and [1] is the handle to the chrome window.
;They are both needed to cleanly close.
Func ChromeCreatePseudoEmbedded($i_Left, $i_Top, $i_Width, $i_Height, $h_Parent, $sURL)
;http://www.autoitscript.com/forum/topic/152173-pseudo-embed-google-chrome/

    Local $acMain[2]

    $acMain[0] = Run(@ProgramFilesDir & "\Google\Chrome\Application\chrome.exe --chrome-frame -kiosk " & $sURL)
    If @error Then
        MsgBox(0, 0, @error)
        Exit
    EndIf

    Local $ah_HWND
    Do
        $ah_HWND = _WinAPI_EnumProcessWindows($acMain[0])
        Sleep(10)
    Until IsArray($ah_HWND)

    $acMain[1] = HWnd($ah_HWND[1][0])

    _WinAPI_SetParent($acMain[1], $h_Parent)
    _WinAPI_SetWindowLong($acMain[1], $GWL_STYLE, $WS_POPUP + $WS_VISIBLE)

    ControlMove($acMain[1], "", "", $i_Left + 1, $i_Top + 1, $i_Width - 2, $i_Height - 2)
    GUISetState(@SW_SHOW, $h_Parent)
    WinActivate($acMain[1])

    Return $acMain

EndFunc   ;==>ChromeCreatePseudoEmbedded